<template>
<!-- 国贸计划重量调整 -->
    <div class="outElectricity">
        <div class="box">
            <div class="box-top">
                <el-form
                    style="overflow: hidden;"
                    :style="filterForm.show ? null : { height: '0px' }"
                    size="mini"
                    label-width="75px"
                >
                    <el-row>
                        <el-col :span="6">
                            <el-form-item label="排产日期">
                                <zj-timegran-date
                                    v-model="filterForm.data.may"
                                    style="width: 100%;"
                                    :type="'daterange'"
                                    :custom ="1"
                                ></zj-timegran-date>
                            </el-form-item>
                        </el-col>
                            <el-col :span="6">
                           <el-form-item label="编号">
                                <el-input
                                    v-model="filterForm.data.id"
                                    style="width: 100%;"
                                    refcous="true"
                                    ></el-input>
                            </el-form-item>
                        </el-col>
                        <el-col :span="6">
                            <el-form-item label="工序">
                            <el-select
                            filterable clearable
                            collapse-tags
                            v-model="filterForm.data.workprocType"
                            multiple
                            placeholder=""
                            style="width: 100%;"
                            >
                            <el-option
                            v-for="item of nameObj.workprocid.arr"
                            :key="item.id"
                            :value="item.id"
                            :label="item.name"
                            ></el-option>
                            </el-select>
                            </el-form-item>
                        </el-col>
                    </el-row>
                </el-form>
                <div class="box-top-gjl">
                    <el-form size="mini" label-width="75px">
                        <el-row>
                            <el-col :span="8">
                                <el-button
                                     type="primary"
                                     size="mini"
                                     icon="el-icon-add-outline"
                                     @click="submitaudit()"
                                     v-privilege="activeMenu + 'audit'"
                                    :loading="loading"
                                >提交审核</el-button>
                                <el-button
                                    type="primary"
                                    size="mini"
                                    v-privilege="activeMenu + 'approve'"
                                    @click="approval()"
                                    >审核</el-button>
                                    <el-button
                                    type="danger"
                                    size="mini"
                                    v-privilege="activeMenu + 'NOAGREE'"
                                    @click="nopass()"
                                    >取消审核</el-button>
                                    <el-button
                                    type="primary"
                                    size="mini"
                                    v-privilege="activeMenu + 'AGREE'"
                                    @click="agreement()"
                                   >同意</el-button>
                                   <el-button
                                    type="danger"
                                    size="mini"
                                    v-privilege="activeMenu + 'reject'"
                                    @click="rejected()"
                                    >取消同意</el-button>
                            </el-col>
                            <el-col :span="8" style="float:right; text-align: right;">
                                <div>
                                    <el-button
                                        class="button"
                                        type="primary"
                                        size="mini"
                                        icon="el-icon-search"
                                        v-if="butPrivilege.QUERY"
                                        @click="getTableData()"
                                    >查询</el-button>
                                    <el-button
                                        size="mini"
                                        :icon="filterForm.show ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"
                                        :title="filterForm.show ? '收起搜索区' : '展开搜索区'"
                                        @click="filterForm.show = !filterForm.show;
                                            $nextTick(() => {
                                                singleTableHeight = getRoleHeight($refs['singleTable'].$el) - 45;
                                            }
                                        );"
                                    >{{ filterForm.show ? '收起' : '展开' }}</el-button>
                                </div>
                            </el-col>
                        </el-row>
                    </el-form>
                </div>
            </div>
            <div class="box-bottom">
                <el-form
                    size="mini"
                    ref="dialog_form_arr"
                    label-width="0px"
                    :model="tableFormDataObj"
                >
                    <el-table stripe
                        id="singleTable"
                        ref="singleTable"
                        :data="tableData"
                        v-loading="tableLoading"
                        style="width: 100%;"
                        :height="singleTableHeight"
                        border
                        size="mini"
                        highlight-current-row
                        @selection-change="handleSelectionChange"
                        show-summary
                        :summary-method="getSummaries"
                        :span-method="arraySpanMethod"
                        :row-class-name="tableRowClassName"
                        @cell-click="cellClick"
                        @expand-change="rowClick"
                    >
                        <el-table-column
                        type="expand"
                        width="40"
                        align="center"
                        v-if="spread"
                        :key="Math.random()"
                        fixed="left"
                         >
                        <template slot-scope="scope">
                         <el-table
                             id="singleTable"
                             :data="expands[scope.row.id]"
                             style="width: 100%;"
                             size="mini"
                             @cell-dblclick = "handleclickChange"
                         >
                        <el-table-column
                            prop="id"
                            label="轮次编号"
                            fixed="left"
                            width="130px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            prop="grades"
                            label="钢种"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            prop="specifications"
                            label="规格"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                            prop="planWeight"
                            label="计划量"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                                <el-form-item
                                    v-if="isClick"
                                    :prop="scope.row.seq + '.planweight'"
                                    :rules="tableFormRules.planWeight"
                                >
                                    <el-input clearable
                                        style="width: 100%;"
                                        @keydown.native="keyDown" :id="scope.$index + scope.column.id"
                                        v-model="scope.row.planWeight"
                                    ></el-input>
                                </el-form-item>
                                <span v-else>{{scope.row.planWeight}}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                            prop="issuedTime"
                            label="下发日期"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            label="操作"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                            <div>
                                <el-button
                                    type="primary"
                                    size="mini"
                                    @click="addSave(scope.row)"
                                >保存</el-button>
                            </div>
                        </template>
                        </el-table-column>
                         </el-table>
                        </template>
                        </el-table-column>
                        <el-table-column
                            type="selection"
                            width="40"
                            align="center"
                            fixed="left"
                            class-name="cnspicuous"
                        ></el-table-column>
                        <el-table-column
                        sortable
                            prop="id"
                            label="国贸订单编号"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                        sortable
                            prop="workprocType"
                            label="工序"
                            align="center"
                            fixed="left"
                            width="69px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                              <span>{{ nameObj.workprocid.obj[scope.row.workprocType] ? nameObj.workprocid.obj[scope.row.workprocType].name : scope.row.workprocType }}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="jhTime"
                            label="排产日期"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                        sortable
                            prop="deliveryDate"
                            label="交货日期"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                         sortable
                            prop="state"
                            label="审核状态"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        >
                         <template slot-scope="scope">
                                <span
                                    :style="{color: nameObj.state.obj[scope.row.state] ? nameObj.state.obj[scope.row.state].color : ''}"
                                >{{ nameObj.state.obj[scope.row.state] ? nameObj.state.obj[scope.row.state].name : scope.row.state }}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="grades"
                            label="钢种"
                            align="center"
                            fixed="left"
                            width="106px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="specifications"
                            label="规格"
                            fixed="left"
                            align="center"
                            width="105px"
                            :show-overflow-tooltip="true"
                            v-if="filterForm.data.gx!='XG'"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="lengths"
                            label="长度"
                            align="center"
                            width="75px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <!-- <el-table-column
                        sortable
                            prop="lengthtimesWidth"
                            label="高度*宽度"
                            align="center"
                            width="110px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column> -->
                        <el-table-column
                        sortable
                            prop="planweight"
                            label="计划量"
                            align="center"
                            width="110px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                                <el-form-item
                                    v-if="(scope.row.state === '0' || scope.row.state === '1') && scope.row.isSelection"
                                    :prop="scope.row.seq + '.planweight'"
                                    :rules="tableFormRules.planWeight"
                                >
                                    <el-input clearable
                                        style="width: 100%;"
                                        @keydown.native="keyDown" :id="scope.$index + scope.column.id"
                                        v-model="tableFormDataObj[scope.row.seq].planweight"
                                        @change="chnageApportvalue(scope.row.seq, tableFormDataObj[scope.row.seq].planweight, scope.$index)"
                                    ></el-input>
                                </el-form-item>
                                <span v-else>{{scope.row.planweight}}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="planWeightOld"
                            align="center"
                            label="原计划量"
                            width="74px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="tzl"
                            align="center"
                            label="调整量"
                            width="74px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="submitter"
                            label="提交人"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                         <el-table-column
                         sortable
                            prop="submitTime"
                            label="提交时间"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="gmReviewer"
                            label="审核人(国贸)"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="gmReviewerTime"
                            label="审核时间(国贸)"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="reviewer"
                            label="审核人(生产部)"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="reviewerTime"
                            label="审核时间(生产部)"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <!-- <el-table-column
                        class-name="gn-TableDownloadExcel-none"
                        label="操作"
                        v-if="czstate"
                        align="center"
                        fixed="right"
                        min-width="200px"
                    >
                        <template slot-scope="scope">
                            <div>
                                 <el-button
                                    type="primary"
                                    size="mini"
                                    v-privilege="activeMenu + 'approve'"
                                    @click="approval()"
                                >批准</el-button>
                                <el-button
                                    type="primary"
                                    size="mini"
                                    v-privilege="activeMenu + 'AGREE'"
                                    @click="agreement(scope.row)"
                                >同意</el-button>
                                <el-button
                                    type="danger"
                                    size="mini"
                                    v-privilege="activeMenu + 'reject'"
                                    @click="rejected(scope.row)"
                                >驳回</el-button>
                            </div>
                        </template>
                    </el-table-column> -->
                    </el-table>
                </el-form>
                <el-pagination
                    layout="total, sizes, prev, pager, next, jumper"
                    :total="total"
                    :page-sizes="[10, 20, 50, 100, 500, 1000]"
                    :page-size="pageSize"
                    :current-page.sync="pageNum"
                    @size-change="tableSizeChange"
                    @current-change="getTableData()"
                    style="text-align: right;margin-top: 10px;"
                ></el-pagination>
            </div>
        </div>
    </div>
</template>

<script>
import { zCheckNumber1 } from '~/utils/validator.js';
import timegranDate from '~/components/zg/timegranDate.vue';
import {formatDate, XtcommonSummaries, getCookie} from '@/utils/util.js';
import store from '@/store/index.js';
export default {
    name: 'outElectricity',
    components: {
        'zj-timegran-date': timegranDate
    },
    data () {
        let setDate = new Date();
        setDate.setDate(15);
        setDate.setMonth((setDate.getMonth() - 1));
        return {
            rowIndex: '',
            columnId: '',
            focusTarget: null,
            seqArr: [],
            editSetFlag: '',
            isCheck: false, // 是否为审核人
            isClick: false,
            filterForm: {
                show: true,
                data: {
                    show: false,
                    id: '',
                    clock: '',
                    clockc: '',
                    workprocType: [],
                    location: [],
                    networkid: [],
                    auditStatus: [],
                    state: '',
                    may: '',
                    unit: '',
                    memo: '',
                    startTime: '',
                    endTime: ''
                },
                rules: {
                },
                disabled: {
                    networkid: false
                }
            },
            pageNum: 1,
            pageSize: 100,
            total: 0,
            singleTableHeight: 100,
            tableData: [
            ],
            expands: {},
            loading: false,
            tableLoading: false,
            multipleSelection: [],
            tableFormDataObj: {},
            tableFormRules: {
                grades: [
                     { required: true, message: '该项不能为空', trigger: 'change' }
                ],
                lengths: [
                     { validator: zCheckNumber1, trigger: 'change' }
                ],
                mendvalue: [
                    // { required: true, message: '该项不能为空', trigger: 'change' },
                    { validator: zCheckNumber1, trigger: 'change' }
                ],
                specifications: [
                    { required: true, message: '该项不能为空', trigger: 'change' }
                ],
                planWeight: [
                     { required: true, message: '该项不能为空', trigger: 'change' },
                     { validator: zCheckNumber1, trigger: 'change' }
                ],
                wastage: [
                    { validator: zCheckNumber1, trigger: 'change' }
                ],
                secondVal: [
                    { validator: zCheckNumber1, trigger: 'change' }
                ],
                kxf_weight: [
                    { required: true, message: '该项不能为空', trigger: 'change' },
                     { validator: zCheckNumber1, trigger: 'change' }
                ],
                yxf_weight: [
                    { required: true, message: '该项不能为空', trigger: 'change' },
                     { validator: zCheckNumber1, trigger: 'change' }
                ],
                bz: [

                ]
            },
            nameObj: {
                state: {
                    obj: {
                        '0': {
                            name: '已编辑',
                            color: '#7a7a7a'
                        },
                        '1': {
                            name: '待审核',
                            color: 'rgb(28, 111, 217)'
                        },
                        '2': {
                            name: '国贸已批准',
                            color: 'rgb(28, 111, 217)'
                        },
                        '3': {
                            name: '生产部已同意',
                            color: 'green'
                        },
                        '4': {
                             name: '审核失败',
                            color: 'red'
                        }
                    },
                    arr: [
                        {
                            name: '已编辑',
                            color: '#7a7a7a'
                        },
                        {
                            name: '待审核',
                            color: 'rgb(28, 111, 217)'
                        },
                        {
                            name: '国贸已批准',
                            color: 'rgb(28, 111, 217)'
                        },
                        {
                            name: '生产部已同意',
                            color: 'green'
                        },
                        {
                             name: '审核失败',
                             color: 'red'
                        }
                    ]
                },
                roleList: {
                    obj: {},
                    arr: []
                },
                type: {
                    obj: {
                        '0': '否',
                        '1': '是'
                    },
                    arr: [
                        {
                            id: '0',
                            name: '否'
                        },
                        {
                            id: '1',
                            name: '是'
                        }
                    ]
                },
                 transportType: {
                    obj: {'0': {name: '火运'}, '1': {name: '汽运'}, '2': {name: '汽运或者火运'}},
                    arr: [
                        {
                            id: '0',
                            name: '火运'
                        },
                        {
                            id: '1',
                            name: '汽运'
                        },
                        {
                            id: '2',
                            name: '汽运或者火运'
                        }
                    ]
                },
                workprocid: {
                    obj: {'AT2004': {name: '炼钢'}, 'AT2005': {name: '一高线'}, 'AT2006': {name: '二高线'}, 'AT2007': {name: '型钢'}},
                    arr: [
                        {
                         id: 'AT2004',
                         name: '炼钢'
                        },
                        {
                         id: 'AT2005',
                         name: '一高线'
                        },
                        {
                         id: 'AT2006',
                         name: '二高线'
                        },
                        {
                         id: 'AT2007',
                         name: '型钢'
                        }
                        ]
                },
                location: {
                    obj: {},
                    arr: [],
                    showDataArr: []
                },
                purpose: {
                    obj: {
                        '0': {name: '标准件'},
                        '1': {name: '铁丝'},
                        '2': {name: '钢丝、弹簧'}
                    },
                    arr: [
                        {
                            id: '0',
                            name: '标准件'
                        },
                        {
                            id: '1',
                            name: '铁丝'
                        },
                        {
                            id: '2',
                            name: '钢丝、弹簧'
                        }
                    ]
                },
                locateid: {
                    obj: {},
                    arr: []
                },
                networkid: {
                    obj: {},
                    arr: []
                },
                userId: {
                    obj: {},
                    arr: []
                },
                unitid: {
                    obj: {},
                    arr: [],
                    defaults: ''
                },
                 grades: {
                    obj: {},
                    arr: []
                },
                specifications: {
                    obj: {},
                    arr: []
                },
                lengthTimeswidth: {
                    obj: {},
                    arr: []
                },
                chemicalStandard: {
                    obj: {},
                    arr: []
                }
            },
            butPrivilege: {
                QUERY: false,
                PUT: false,
                CHECK: false,
                UNDOCHECK: false
            },
            loginName: getCookie('loginName'),
            userInfo: {},
            userRoles: {},
            qrRole: [],
            spread: false,
            checkstate: false,
            czstate: false,
            store
        }
    },
    created () {
        // 获取按钮权限
        this.activeMenu = window.localStorage.getItem('activeMenu');
        for (let key in this.butPrivilege) {
            this.butPrivilege[key] = this.checkPrivilege(this.activeMenu + key);
        }
    },
    mounted () {
        let that = this;
        window.PEDataObj = {
            // 将数据绑定到window上，供main页面使用
            vm: that,
            // tableArr：用于导出成Excel的表格的信息
            tableArr: [
                {
                    name: '',
                    id: 'singleTable'
                }
            ]
        };
        that.$nextTick(() => {
            // 立即获取的height有一定偏差，通过setTimeout延迟来解决
            setTimeout(() => {
                that.singleTableHeight = that.getRoleHeight(that.$refs['singleTable'].$el) - 45;
            }, 1);
        });
        // 接收路由参数
        if (that.$route.query.workproc_type) {
            that.filterForm.data.workproc_type = that.$route.query.workproc_type;
        }
        // 当有审核与取消审核权限时，默认其为审核人，审核人无法修改数据
        if (that.butPrivilege.CHECK || that.butPrivilege.UNDOCHECK) {
            that.isCheck = true;
        }
        that.getRoles();
        that.getUnitIdData();
        that.getLocateIdData();
        that.getlengthTimesWidth();
    },
    methods: {
        //  计算树区域高度
        getRoleHeight (dom) {
            return window.innerHeight - dom.offsetTop;
        },
        // 自定义的表格合计方法：只给指定列进行合计
        getSummaries (param) {
            const prop = ['planweight', 'planWeightOld', 'tzl']; // 合计列绑定的prop
            return XtcommonSummaries(param, prop);
        },
        rowClick (row) {
            if (row.state === '3') {
             let that = this,
             params = {
                parentid: row.id
             };
            that.tableLoading = true;
            let url = 'pass/ems/v1/emsprodplanrounds/getRounds';
            that.axios.get(url, {
                params: params
            })
                .then(function (res) {
                    if (res.code === '0') {
                        let chirItem = Object.keys(res.data[0])[0];
                        that.expands[chirItem] = res.data[0][chirItem];
                    } else {
                        that.$message.error(res.message);
                    }
                    that.tableLoading = false;
                }).catch(function () {
                    that.tableLoading = false;
                });
            }
        },
        // 获取高线钢种
        getGrades () {
            let that = this
            let type = '';
            if (that.filterForm.data.gx === 'GX') {
               type = '高线'
            }
            if (that.filterForm.data.gx === 'XG') {
               type = '型钢'
            }
            let url = 'pass/product/v1/emssteel/getGrades/?type=' + type;
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.steelName
                            })
                                obj[item.id] = {
                                name: item.steelName,
                                id: item.id
                            }
                        }
                        that.nameObj.grades.arr = arr;
                        that.nameObj.grades.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取高线规格
        getSpecifications () {
            let that = this
            let url = 'pass/product/v1/emssteel/getSpecifications/?type=' + '高线';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.specName
                            })
                            obj[item.id] = {
                                name: item.specName,
                                unitid: item.id
                            }
                        }
                        that.nameObj.specifications.arr = arr;
                        that.nameObj.specifications.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取高线执行标准
         getStandards () {
             let that = this
            let url = 'pass/product/v1/emsstandard/getStandards';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.basecode,
                                name: item.basename
                            })
                        }
                        that.nameObj.chemicalStandard.arr = arr;
                        that.nameObj.chemicalStandard.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢钢种
        getGradesASLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmbasesteel/getBase'
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = {
                                name: item.name,
                                id: item.id
                            }
                        }
                        that.nameObj.grades.arr = arr;
                        that.nameObj.grades.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢规格
        getSpecificationsAsLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmbasespecbillet/getbasespecbillet';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = {
                                name: item.name,
                                id: item.id
                            }
                        }
                        that.nameObj.specifications.arr = arr;
                        that.nameObj.specifications.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢化学成分标准
        getStandardsAsLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmstdchem/getstdchem';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.basecode,
                                name: item.standardgb
                            })
                        }
                        that.nameObj.chemicalStandard.arr = arr;
                        that.nameObj.chemicalStandard.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取型钢宽度*长度
        getlengthTimesWidth () {
            let that = this
            let url = 'pass/ems/v1/emsprodplanrounds/getlengthTimesWidth';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.lengthTimesWidth
                            })
                        }
                        that.nameObj.lengthTimeswidth.arr = arr;
                        that.nameObj.lengthTimeswidth.obj = obj;
                        console.log(that.nameObj.lengthTimeswidth);
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        connn () {
            let that = this;
            if (!that.filterForm.data.networkid || that.filterForm.data.networkid.length === 0) {
                that.nameObj.location.showDataArr = that.nameObj.workprocid.arr;
            } else {
                let url = 'pass/ems/v1/emsprodplanmonths/getWorkprocs'
                that.axios.get(url)
                    .then(function (res) {
                        if (res.code === '0') {
                            let arr = [];
                            for (let item of res.data) {
                                arr.push({
                                    id: item.id,
                                    name: item.name
                                })
                            }
                            that.nameObj.location.showDataArr = arr;
                        } else {
                            that.$message.error(res.message);
                        }
                    });
            }
        },
        // 保存数据
        dataSave () {
            let that = this;
            let SubmitData = {
                jhTime: that.dialog.editorBox.form.data.jhTime,
                grades: that.dialog.editorBox.form.data.grades,
                unitid: '008',
                chemicalStandard: that.dialog.editorBox.form.data.chemicalStandard,
                planWeight: that.dialog.editorBox.form.data.planWeight,
                specifications: that.dialog.editorBox.form.data.specifications,
                transportType: that.dialog.editorBox.form.data.transportType,
                memo: that.dialog.editorBox.form.data.memo,
                workprocType: that.filterForm.data.workproc_type,
                lengths: that.dialog.editorBox.form.data.lengths,
                purpose: that.dialog.editorBox.form.data.purpose,
                iateralArea: that.dialog.editorBox.form.data.iateralArea,
                deliveryDate: that.dialog.editorBox.form.data.deliveryDate,
                lengthTimesWidth: that.dialog.editorBox.form.data.lengthTimesWidth,
                dimension: that.dialog.editorBox.form.data.dimension,
                surfaceStandard: that.dialog.editorBox.form.data.surfaceStandard,
                state: '0'
            };
            that.$refs['dialog_form'].validate((valid) => {
               if (valid) {
                        that.loading = true;
                        that.axios.post('pass/ems/v1/emsgmpcjhs/', SubmitData, {
                            contentType: 'application/json'
                        })
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '新增成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                }
            });
        },
        // 获取位置
        getLocateIdData () {
            let that = this
            let url = 'pass/ems/v1/trmlocations/getidandname/';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                        }
                        that.nameObj.locateid.arr = arr;
                        that.nameObj.locateid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取表格中的数据
        getTableData (pageNum) {
            let that = this,
            params = {},
                pData = {
                   id: that.filterForm.data.id,
                   workprocType: that.filterForm.data.workprocType.toString(),
                   startTime: that.filterForm.data.may[0],
                   endTime: that.filterForm.data.may[1],
                   auditStatus: that.filterForm.data.auditStatus.toString()
                };
                for (let key in pData) {
                    if (pData[key]) {
                        params[key] = pData[key];
                    }
                }
            that.pageNum = pageNum || that.pageNum;
            that.tableLoading = true;
            let url = 'pass/ems/v1/emsgmpcjhs/getXsDdDate/?pageNum=' + that.pageNum + '&pageSize=' + that.pageSize;
            that.axios.get(url, {
                params: params
            })
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        for (let i = 0; i < res.data.list.length; i++) {
                            let item = res.data.list[i];
                            arr.push({
                                seq: i,
                                id: item.ID,
                                jhTime: item.JH_TIME,
                                state: item.AUDIT_STATUS,
                                grades: item.GRADES,
                                specifications: item.SPECIFICATIONS,
                                lengths: item.LENGTHS,
                                workprocType: item.WORKPROC_TYPE,
                                reviewer: item.REVIEWER,
                                reviewerTime: item.REVIEWER_TIME,
                                submitter: item.SUBMITTER,
                                submitTime: item.SUBMIT_TIME,
                                planweight: item.PLAN_WEIGHT,
                                planWeightOld: item.PLAN_WEIGHT_OLD,
                                deliveryDate: item.DELIVERY_DATE,
                                gmReviewer: item.GM_REVIEWER,
                                gmReviewerTime: item.GM_REVIEWER_TIME,
                                tzl: item.TZL
                            });
                        }
                        that.total = res.data.total;
                        that.tableData = arr;
                        that.getAdds();
                    } else {
                        that.$message.error(res.message);
                    }
                    that.$nextTick(() => {
                        setTimeout(() => {
                            that.singleTableHeight = that.getRoleHeight(that.$refs['singleTable'].$el) - 46;
                        }, 1);
                    });
                    that.tableLoading = false;
                }).catch(function () {
                    that.tableLoading = false;
                });
        },
        arraySpanMethod ({ row, column, rowIndex, columnIndex }) {
            let that = this;
            let tableData = this.$refs.singleTable.tableData
            let c1 = row.workprocid;
            let c2 = row.location;
            let c3 = row.workshop;
            let c4 = row.clock;
            let c5 = row.clocke;
            let rowsPan = 1;
            if (column['property'] === 'workprocid' || column['property'] === 'adds' || column['property'] === 'rxj' || column['property'] === 'yhj') {
                if (rowIndex > 0 && c1 === tableData[rowIndex - 1].workprocid && c2 === tableData[rowIndex - 1].location &&
                c3 === tableData[rowIndex - 1].workshop && c4 === tableData[rowIndex - 1].clock && c5 === tableData[rowIndex - 1].clocke) {
                    return {
                        rowspan: 0,
                        colspan: 0
                    };
                };
                while (tableData[rowIndex + rowsPan] && c1 === tableData[rowIndex + rowsPan].workprocid && c2 === tableData[rowIndex + rowsPan].location &&
                    c3 === tableData[rowIndex + rowsPan].workshop && c4 === tableData[rowIndex + rowsPan].clock && c5 === tableData[rowIndex + rowsPan].clocke) {
                    rowsPan += 1
                }
                return {
                    rowspan: rowsPan,
                    colspan: 1
                };
            }
        },
        but_add () {
            let that = this;
            that.dialog.editorBox.form.data.grades = '';
            that.dialog.editorBox.form.data.transportType = '';
            that.dialog.editorBox.form.data.specifications = '';
            that.dialog.editorBox.form.data.unitid = '';
            that.dialog.editorBox.form.data.memo = '';
            that.dialog.editorBox.form.data.chemicalStandard = '';
            that.dialog.editorBox.form.data.planWeight = '';
            that.dialog.editorBox.form.data.lengths = '';
            that.dialog.editorBox.form.data.lengthTimesWidth = '';
            that.dialog.editorBox.form.data.memo = '';
            that.dialog.editorBox.show = true;
             setTimeout(() => {
                that.$refs['dialog_form'].clearValidate();
            }, 100);
        },
        but_copy () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                if (valid) {
                    that.dialog.editorBox2.show = true;
                setTimeout(() => {
                    that.$refs['dialog_form2'].clearValidate();
            }, 100);
                }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
      },
        // 改变表格显示条数
        tableSizeChange (val) {
            let that = this;
            that.pageSize = val;
            that.getTableData(1);
        },
        keyDown (event1, disabledFlag) {
            let tdTarget = event1.target;
            let _this = this;
            while (tdTarget.tagName !== 'TD') {
                tdTarget = tdTarget.parentElement;
            }
            // 如果按下键盘下键或者回车键
            if (event.keyCode === 40 || event.keyCode === 13) {
                let index = parseInt(this.rowIndex);
                // index++;
                if (index !== this.seqArr[this.seqArr.length - 1]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i + 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = index + this.columnId;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 38) { // 键盘上键
                let index = parseInt(this.rowIndex);
                if (index !== this.seqArr[0]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i - 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = index + this.columnId;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 37) { // 键盘左键
                $(tdTarget).prevAll().find('input:text').last().click();
            } else if (event.keyCode === 39) { // 键盘右键
                $(tdTarget).nextAll().find('input').eq(0).click();
            }
        },
        // 只允许对未接受的数据进行操作
        checkboxT (row, index) {
          if (row.state === '3' && !this.isCheck) {
                return false;
            } else {
                return true;
            }
        },
        // 获取标准计量单位
        getUnitIdData () {
            let that = this
            let url = 'pass/ems/v1/trmunits/getIdAndName';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                            if (item.name === '吨') {
                                that.nameObj.unitid.defaults = that.nameObj.unitid.defaults ? that.nameObj.unitid.defaults : item.id;
                            }
                        }
                        that.nameObj.unitid.arr = arr;
                        that.nameObj.unitid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        handleSelectionChange (val) {
            let that = this;
            let tableFormDataObj = {};
            let arr = [];
            for (let item of val) {
                arr.push(item.seq);
            }
            this.seqArr = arr.sort(sortNumber);
            for (let item of that.tableData) {
                item.isSelection = false;
            }
            for (let item of val) {
                let obj = {};
                let xId = item.seq;
                if (that.tableFormDataObj[xId]) {
                    // 如果已存在该数据则使用该数据
                    tableFormDataObj[xId] = that.tableFormDataObj[xId];
                } else {
                    // 负责则从对应行中获取行内原数据
                    for (let key in item) {
                        obj[key] = item[key];
                    }
                    item.realvalue = (!isNaN(Number(item.apportvalue)) && !isNaN(Number(item.wastage))) ? Number(item.apportvalue) + Number(item.wastage) - Number(item.secondVal) : item.realvalue;
                    tableFormDataObj[xId] = obj;
                }
                item.isSelection = true;
            }
            for (let item of that.tableData) {
                if (item.isSelection === false) {
                    item.realvalue = (!isNaN(Number(item.apportvalue)) && !isNaN(Number(item.wastage))) ? Number(item.apportvalue) + Number(item.wastage) - Number(item.secondVal) : item.realvalue;
                }
            }
            that.tableFormDataObj = tableFormDataObj;
            that.multipleSelection = val;
            this.getAdds();
        },
        handleclickChange (row, column, cell, event) {
            let that = this;
            if (column.label === '计划量' && !this.isClick) {
                 that.isClick = true;
            } else {
                 that.isClick = false;
            }
        },

        getApportValue (seq, value, rowIndex, event) {
            let that = this;
            if (!isNaN(Number(value))) {
                if (!isNaN(Number(that.tableFormDataObj[seq].mintvalue)) && !isNaN(Number(that.tableFormDataObj[seq].mendvalue)) && that.tableFormDataObj[seq].mintvalue !== null && that.tableFormDataObj[seq].mendvalue !== null) {
                    let poor = that.floatComputed(Number(that.tableFormDataObj[seq].mendvalue), Number(that.tableFormDataObj[seq].mintvalue), '-');
                    that.tableFormDataObj[seq].apportvalue = that.floatComputed(poor, Number(that.tableFormDataObj[seq].mods), '*').toFixed(0);
                    let rv1 = that.floatComputed(Number(that.tableFormDataObj[seq].apportvalue), Number(that.tableFormDataObj[seq].wastage), '+');
                    that.tableFormDataObj[seq].realvalue = that.floatComputed(rv1, Number(that.tableFormDataObj[seq].secondVal), '-').toFixed(0);
                    that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
                }
            }
        },
        // 手动修改抄度后计算实际电量
        chnageApportvalue (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].wastage))) {
                that.tableFormDataObj[seq].realvalue = that.floatComputed(Number(value), Number(that.tableFormDataObj[seq].wastage), '+').toFixed(0);
            }
            that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
        },
        // 手动修改损耗后计算实际电量
        chnageWastage (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].apportvalue)) && that.tableFormDataObj[seq].apportvalue !== null) {
                let rv1 = that.floatComputed(Number(value), Number(that.tableFormDataObj[seq].apportvalue), '+');
                that.tableFormDataObj[seq].realvalue = that.floatComputed(rv1, Number(that.tableFormDataObj[seq].secondVal), '-').toFixed(0);
                that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
            }
        },
        // 手动修改二次转供电后计算实际电量
        chnageSecondVal (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].apportvalue)) && that.tableFormDataObj[seq].apportvalue !== null) {
                let val1 = that.floatComputed(Number(that.tableFormDataObj[seq].apportvalue), Number(that.tableFormDataObj[seq].wastage), '+');
                that.tableFormDataObj[seq].realvalue = that.floatComputed(val1, Number(value), '-').toFixed(0);
                that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
            }
        },
        // 统计合计值
        getAdds () {
            let that = this;
            let wlarr = [];
            for (var i = 0; i < that.tableData.length; i++) {
               wlarr.push(that.tableData[i].workprocid + '-' + that.tableData[i].location + '-' + that.tableData[i].workshop + '-' + that.tableData[i].clock + '-' + that.tableData[i].clocke);
            }
            let wls = [...new Set(wlarr)]
            let arrs = [];
            for (let wl of wls) {
                let rxj = 0;
                let yhj = 0;
                for (let item of that.tableData) {
                    if (wl === item.workprocid + '-' + item.location + '-' + item.workshop + '-' + item.clock + '-' + item.clocke) {
                        rxj = that.floatComputed(Number(item.weightDay), rxj, '+');
                        yhj = that.floatComputed(Number(item.weightMonth), yhj, '+');
                    }
                }
                for (let i = 0; i < that.tableData.length; i++) {
                    if (wl === that.tableData[i].workprocid + '-' + that.tableData[i].location + '-' + that.tableData[i].workshop + '-' + that.tableData[i].clock + '-' + that.tableData[i].clocke) {
                        that.tableData[i].rxj = rxj;
                        that.tableData[i].yhj = yhj;
                    }
                }
            }
        },
        // 展示实际电量
        showRealValue (rowIndex, value) {
            let that = this;
            for (let i = 0; i < that.tableData.length; i++) {
                if (i === rowIndex) {
                    that.tableData[i].realvalue = value;
                }
            }
            this.getAdds();
        },
        // 批量修改
        but_edit_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                jhTime: that.tableFormDataObj[key].jhTime,
                                grades: that.tableFormDataObj[key].grades,
                                transportType: that.tableFormDataObj[key].transportType,
                                specifications: that.tableFormDataObj[key].specifications,
                                unitid: that.tableFormDataObj[key].unitid,
                                memo: that.tableFormDataObj[key].memo,
                                workprocType: that.filterForm.data.workproc_type,
                                chemicalStandard: that.tableFormDataObj[key].chemicalStandard,
                                planWeight: that.tableFormDataObj[key].planweight,
                                createTime: that.tableFormDataObj[key].createtime,
                                purpose: that.tableFormDataObj[key].purpose,
                                createMan: that.tableFormDataObj[key].createman,
                                updateTime: that.tableFormDataObj[key].updatetime,
                                updateMan: that.tableFormDataObj[key].updateman,
                                state: that.tableFormDataObj[key].state,
                                lengths: that.tableFormDataObj[key].lengths,
                                surfaceStandard: that.tableFormDataObj[key].surfacestandard,
                                deliveryDate: that.tableFormDataObj[key].deliveryDate,
                                dimension: that.tableFormDataObj[key].dimension,
                                iateralArea: that.tableFormDataObj[key].iateralarea,
                                lengthTimesWidth: that.tableFormDataObj[key].lengthtimeswidth
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/batchupdate', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        getRoles () {
            let that = this;
            // 获取用户信息
            this.store.dispatch('getUserInfo').then((res) => {
                this.userInfo = res.data;
                that.axios.get('pass/v1/sysuserroles/?userId=' + res.data.userId + '&pageNum=1&pageSize=100').then(rest => {
                  if (rest) {
                    for (let i = 0; i < rest.data.list.length; i++) {
                      that.qrRole.push(rest.data.list[i].roleId)
                    }
                      that.userRoles = rest.data.list; // 获取用户角色关联信息
                  }
                    let roleId = this.nameObj.roleList.obj['生产部-生产处'].id;
                    let gmywid = this.nameObj.roleList.obj['国贸-业务人员'].id;
                    let gmldid = this.nameObj.roleList.obj['国贸-部门领导'].id;
                    if (this.qrRole.includes(roleId)) {
                        this.filterForm.data.auditStatus.push('2', '3', '4');
                        this.spread = true;
                        this.czstate = true;
                    }
                    if (this.qrRole.includes(gmywid)) {
                        this.filterForm.data.auditStatus.push('0', '1', '2', '3', '4');
                        this.checkstate = true;
                    }
                    if (this.qrRole.includes(gmldid)) {
                         this.filterForm.data.auditStatus.push('1', '2', '3', '4');
                        this.czstate = true;
                    }
                    this.getTableData();
        })
            });
            // 获取角色信息
            this.store.dispatch('system/rolesManage/list').then(res => {
              if (res.code === '0') {
                this.nameObj.roleList.arr = res.data;
                for (let obj of res.data) {
                    this.nameObj.roleList.obj[obj.roleName] = {
                        name: obj.roleName,
                        id: obj.id
                    };
                }
                } else {
              this.$message.error(res.message);
            }
            });
        },
        // 批量复制
        but_copy_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                jhTime: that.dialog.editorBox2.form.data.may,
                                grades: that.tableFormDataObj[key].grades,
                                transportType: that.tableFormDataObj[key].transportType,
                                specifications: that.tableFormDataObj[key].specifications,
                                unitid: that.tableFormDataObj[key].unitid,
                                memo: that.tableFormDataObj[key].memo,
                                workprocType: that.filterForm.data.workproc_type,
                                chemicalStandard: that.tableFormDataObj[key].chemicalStandard,
                                planWeight: that.tableFormDataObj[key].planweight,
                                createTime: that.tableFormDataObj[key].createTime,
                                createMan: that.tableFormDataObj[key].createman,
                                updateTime: that.tableFormDataObj[key].updateTime,
                                deliveryDate: that.tableFormDataObj[key].deliveryDate,
                                updateMan: that.tableFormDataObj[key].updateman,
                                state: that.tableFormDataObj[key].state,
                                lengths: that.tableFormDataObj[key].lengths,
                                surfaceStandard: that.tableFormDataObj[key].surfacestandard,
                                dimension: that.tableFormDataObj[key].dimension,
                                iateralArea: that.tableFormDataObj[key].iateralarea,
                                lengthTimesWidth: that.tableFormDataObj[key].lengthtimeswidth
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/batchcopy', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '复制成功',
                                        type: 'success'
                                    });
                                    that.dialog.editorBox2.show = false;
                                    that.getTableData();
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 保存数据
        addSave (row) {
         let that = this;
         let SubmitData = {
             id: row.id,
             planWeight: row.planWeight
         }
         that.axios.put('pass/ems/v1/emsprodplanrounds/addSave', SubmitData)
             .then(function (res) {
               if (res.code === '0') {
                    that.$message({
                    message: '保存成功',
                    type: 'success'
                    });
                    that.isClick = false;
               } else {
                   that.$message.error(res.message);
               }
             }).catch(function () {
                that.loading = false;
            });
        },
        // 提交审核
         submitaudit () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                planWeight: that.tableFormDataObj[key].planweight,
                                auditStatus: '1',
                                planWeightOld: that.tableFormDataObj[key].planWeightOld
                            });
                        }
                           that.loading = true;
                           that.axios.put('pass/ems/v1/emsprodplanweightadjustments/submitaudit', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '提交成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                    }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 批准
        approval () {
        let that = this;
        if (that.multipleSelection.length > 0) {
            that.$refs['dialog_form_arr'].validate((valid, obj) => {
                if (valid) {
                    let SubmitData = [];
                    for (let key in that.tableFormDataObj) {
                        SubmitData.push({
                            id: that.tableFormDataObj[key].id
                        });
                    }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsprodplanweightadjustments/approval/', SubmitData)
                          .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '提交成功',
                                    type: 'success'
                                });
                                that.getTableData();
                                that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                          }).catch(function () {
                              that.loading = false;
                          })
                }
            });
        } else {
            this.$message.error('至少要选择一条数据');
        }
        // that.axios.put('pass/ems/v1/emsprodplanweightadjustments/approval/' + row.id)
        // .then(function (res) {
        //     if (res.code === '0') {
        //         that.$message({
        //             message: '操作成功',
        //             type: 'success'
        //         });
        //         that.getTableData();
        //     } else {
        //          that.$message.error(res.message);
        //     }
        // }).catch(function () {
        //     that.loading = false;
        // });
        },
        // 不通过
        nopass () {
        let that = this;
        if (that.multipleSelection.length > 0) {
            that.$refs['dialog_form_arr'].validate((valid, obj) => {
                if (valid) {
                    let SubmitData = [];
                    for (let key in that.tableFormDataObj) {
                        SubmitData.push({
                            id: that.tableFormDataObj[key].id
                        });
                    }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsprodplanweightadjustments/nopass/', SubmitData)
                          .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '提交成功',
                                    type: 'success'
                                });
                                that.getTableData();
                                that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                          }).catch(function () {
                              that.loading = false;
                          })
                }
            });
        } else {
            this.$message.error('至少要选择一条数据');
        }
        },
        rejected () {
        let that = this;
        if (that.multipleSelection.length > 0) {
            that.$refs['dialog_form_arr'].validate((valid, obj) => {
                if (valid) {
                    let SubmitData = [];
                    for (let key in that.tableFormDataObj) {
                        SubmitData.push({
                            id: that.tableFormDataObj[key].id
                        });
                    }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsprodplanweightadjustments/rejected/', SubmitData)
                          .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '提交成功',
                                    type: 'success'
                                });
                                that.getTableData();
                                that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                          }).catch(function () {
                              that.loading = false;
                          })
                }
            });
        } else {
            this.$message.error('至少要选择一条数据');
        }
        },
        agreement () {
        let that = this;
        if (that.multipleSelection.length > 0) {
            that.$refs['dialog_form_arr'].validate((valid, obj) => {
                if (valid) {
                    let SubmitData = [];
                    for (let key in that.tableFormDataObj) {
                        SubmitData.push({
                            id: that.tableFormDataObj[key].id
                        });
                    }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsprodplanweightadjustments/agreement/', SubmitData)
                          .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '提交成功',
                                    type: 'success'
                                });
                                that.getTableData();
                                that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                          }).catch(function () {
                              that.loading = false;
                          })
                }
            });
        } else {
            this.$message.error('至少要选择一条数据');
        }
        },
        // 下发
         issue (state) {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                workprocType: that.filterForm.data.workproc_type,
                                state: state
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/updatestate', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 批量删除
        but_del_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                let SubmitData = [];
                for (let item of that.multipleSelection) {
                    SubmitData.push({
                        id: item.id,
                        state: item.state,
                        sqno: item.sqno
                    });
                }
                that.$confirm('是否删除已选数据?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    state: 'warning'
                }).then(() => {
                    that.axios.delete('pass/ems/v1/emsgmpcjhs/delete', {
                        data: SubmitData,
                        contentType: 'application/json;charset=UTF-8'
                    })
                        .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '删除成功',
                                    type: 'success'
                                });
                                that.getTableData();
                            } else {
                                that.$message.error(res.message);
                            }
                        }).catch(function () {
                        });
                }).catch(() => {
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        tableRowClassName ({row, rowIndex}) {
            // 把每一行的索引放进row
            row.index = rowIndex;
        },
        cellClick (row, column, cell, event) {
            let _this = this;
            this.rowIndex = row.index;
            this.columnId = column.id;
            _this.editSetFlag = row.index + column.id;
            _this.focusTarget = event.target;
            while (_this.focusTarget.tagName !== 'TD') {
                _this.focusTarget = _this.focusTarget.parentElement;
            }
            _this.$nextTick(() => {
                let target = this.focusTarget;
                $(target).find('input').focus();
            });
        }
    }
}
function sortNumber (a, b) {
  return a - b
}
</script>

<style lang="less">
.outElectricity{
    min-width: 700px;
    height: 100%;
    .box {
        height: 100%;
        padding: 15px 15px 0 15px;
        .box-top {
            .el-form-item {
                margin-bottom: 7px;
            }
            .box-top-gjl {
                overflow: hidden;
                padding: 7px 0;
                border-top: 1px solid #ccc;
            }
        }
        .rowDisable td {
            color: #6bb025 !important;
        }
        .el-table .el-table__row {
            height: 35px;
        }
        .el-table__body .el-form-item--mini.el-form-item {
            margin: 0px;
            .error {
                overflow: hidden;
                color: #f56c6c;
                font-size: 12px;
                line-height: 1;
            }
        }
    }
    .color_no {
        color: #7a7a7a;
    }
    .color_yes {
        color: #1a9f17;
    }
    .cnspicuous .el-checkbox__input.is-disabled .el-checkbox__inner {
        background-color: #dcdfe6;
        border-color: #babbbf;
    }
}
</style>
